Index: /palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- /palm/trunk/SOURCE/check_parameters.f90	(revision 2036)
+++ /palm/trunk/SOURCE/check_parameters.f90	(revision 2037)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Anelastic approximation implemented
 ! 
 ! Former revisions:
@@ -432,5 +432,6 @@
     USE netcdf_interface,                                                      &
         ONLY:  dopr_unit, do2d_unit, do3d_unit, netcdf_data_format,            &
-               netcdf_data_format_string
+               netcdf_data_format_string, dots_unit, heatflux_output_unit,     &
+               waterflux_output_unit, momentumflux_output_unit
 
     USE particle_attributes
@@ -837,4 +838,89 @@
 
     ENDIF
+
+!
+!-- Check approximation
+    IF ( TRIM( approximation ) /= 'boussinesq'   .AND.   &
+         TRIM( approximation ) /= 'anelastic' )  THEN
+       message_string = 'unknown approximation: approximation = "' //    &
+                        TRIM( approximation ) // '"'
+       CALL message( 'check_parameters', 'PA0000', 1, 2, 0, 6, 0 )
+    ENDIF
+
+!
+!-- Check approximation requirements
+    IF ( TRIM( approximation ) == 'anelastic'   .AND.   &
+         TRIM( momentum_advec ) /= 'ws-scheme' )  THEN
+       message_string = 'Anelastic approximation requires: ' //                &
+                        'momentum_advec = "ws-scheme"'
+       CALL message( 'check_parameters', 'PA0000', 1, 2, 0, 6, 0 )
+    ENDIF
+    IF ( TRIM( approximation ) == 'anelastic'   .AND.   &
+         TRIM( psolver ) == 'multigrid' )  THEN
+       message_string = 'Anelastic approximation currently only supports: ' // &
+                        'psolver = "poisfft", ' // &
+                        'psolver = "sor" and ' // &
+                        'psolver = "multigrid_noopt"'
+       CALL message( 'check_parameters', 'PA0000', 1, 2, 0, 6, 0 )
+    ENDIF
+    IF ( TRIM( approximation ) == 'anelastic'   .AND.   &
+         conserve_volume_flow )  THEN
+       message_string = 'Anelastic approximation is not allowed with:' //      &
+                        'conserve_volume_flow = .TRUE.'
+       CALL message( 'check_parameters', 'PA0000', 1, 2, 0, 6, 0 )
+    ENDIF
+
+!
+!-- Check flux input mode
+    IF ( TRIM( flux_input_mode ) /= 'dynamic'    .AND.   &
+         TRIM( flux_input_mode ) /= 'kinematic'  .AND.   &
+         TRIM( flux_input_mode ) /= 'approximation-specific' )  THEN
+       message_string = 'unknown flux input mode: flux_input_mode = "' //      &
+                        TRIM( flux_input_mode ) // '"'
+       CALL message( 'check_parameters', 'PA0000', 1, 2, 0, 6, 0 )
+    ENDIF
+!-- Set flux input mode according to approximation if applicable
+    IF ( TRIM( flux_input_mode ) == 'approximation-specific' )  THEN
+       IF ( TRIM( approximation ) == 'anelastic' )  THEN
+          flux_input_mode = 'dynamic'
+       ELSEIF ( TRIM( approximation ) == 'boussinesq' )  THEN
+          flux_input_mode = 'kinematic'
+       ENDIF
+    ENDIF
+
+!
+!-- Check flux output mode
+    IF ( TRIM( flux_output_mode ) /= 'dynamic'    .AND.   &
+         TRIM( flux_output_mode ) /= 'kinematic'  .AND.   &
+         TRIM( flux_output_mode ) /= 'approximation-specific' )  THEN
+       message_string = 'unknown flux output mode: flux_output_mode = "' //    &
+                        TRIM( flux_output_mode ) // '"'
+       CALL message( 'check_parameters', 'PA0000', 1, 2, 0, 6, 0 )
+    ENDIF
+!-- Set flux output mode according to approximation if applicable
+    IF ( TRIM( flux_output_mode ) == 'approximation-specific' )  THEN
+       IF ( TRIM( approximation ) == 'anelastic' )  THEN
+          flux_output_mode = 'dynamic'
+       ELSEIF ( TRIM( approximation ) == 'boussinesq' )  THEN
+          flux_output_mode = 'kinematic'
+       ENDIF
+    ENDIF
+
+!
+!-- set the flux output units according to flux_output_mode
+    IF ( TRIM( flux_output_mode ) == 'kinematic' ) THEN
+        heatflux_output_unit              = 'K m/s'
+        waterflux_output_unit             = 'kg/kg m/s'
+        momentumflux_output_unit          = 'm2/s2'
+    ELSEIF ( TRIM( flux_output_mode ) == 'dynamic' ) THEN
+        heatflux_output_unit              = 'W/m2'
+        waterflux_output_unit             = 'W/m2'
+        momentumflux_output_unit          = 'N/m2'
+    ENDIF
+
+!-- set time series output units for fluxes
+    dots_unit(14:16) = heatflux_output_unit
+    dots_unit(21)    = waterflux_output_unit
+    dots_unit(19:20) = momentumflux_output_unit
 
 !
@@ -2115,5 +2201,5 @@
           CASE ( 'w"u"' )
              dopr_index(i) = 12
-             dopr_unit(i)  = 'm2/s2'
+             dopr_unit(i)  = TRIM ( momentumflux_output_unit )
              hom(:,2,12,:) = SPREAD( zw, 2, statistic_regions+1 )
              IF ( constant_flux_layer )  hom(nzb,2,12,:) = zu(1)
@@ -2121,10 +2207,10 @@
           CASE ( 'w*u*' )
              dopr_index(i) = 13
-             dopr_unit(i)  = 'm2/s2'
+             dopr_unit(i)  = TRIM ( momentumflux_output_unit )
              hom(:,2,13,:) = SPREAD( zw, 2, statistic_regions+1 )
 
           CASE ( 'w"v"' )
              dopr_index(i) = 14
-             dopr_unit(i)  = 'm2/s2'
+             dopr_unit(i)  = TRIM ( momentumflux_output_unit )
              hom(:,2,14,:) = SPREAD( zw, 2, statistic_regions+1 )
              IF ( constant_flux_layer )  hom(nzb,2,14,:) = zu(1)
@@ -2132,25 +2218,25 @@
           CASE ( 'w*v*' )
              dopr_index(i) = 15
-             dopr_unit(i)  = 'm2/s2'
+             dopr_unit(i)  = TRIM ( momentumflux_output_unit )
              hom(:,2,15,:) = SPREAD( zw, 2, statistic_regions+1 )
 
           CASE ( 'w"pt"' )
              dopr_index(i) = 16
-             dopr_unit(i)  = 'K m/s'
+             dopr_unit(i)  = TRIM ( heatflux_output_unit )
              hom(:,2,16,:) = SPREAD( zw, 2, statistic_regions+1 )
 
           CASE ( 'w*pt*' )
              dopr_index(i) = 17
-             dopr_unit(i)  = 'K m/s'
+             dopr_unit(i)  = TRIM ( heatflux_output_unit )
              hom(:,2,17,:) = SPREAD( zw, 2, statistic_regions+1 )
 
           CASE ( 'wpt' )
              dopr_index(i) = 18
-             dopr_unit(i)  = 'K m/s'
+             dopr_unit(i)  = TRIM ( heatflux_output_unit )
              hom(:,2,18,:) = SPREAD( zw, 2, statistic_regions+1 )
 
           CASE ( 'wu' )
              dopr_index(i) = 19
-             dopr_unit(i)  = 'm2/s2'
+             dopr_unit(i)  = TRIM ( momentumflux_output_unit )
              hom(:,2,19,:) = SPREAD( zw, 2, statistic_regions+1 )
              IF ( constant_flux_layer )  hom(nzb,2,19,:) = zu(1)
@@ -2158,5 +2244,5 @@
           CASE ( 'wv' )
              dopr_index(i) = 20
-             dopr_unit(i)  = 'm2/s2'
+             dopr_unit(i)  = TRIM ( momentumflux_output_unit )
              hom(:,2,20,:) = SPREAD( zw, 2, statistic_regions+1 )
              IF ( constant_flux_layer )  hom(nzb,2,20,:) = zu(1)
@@ -2164,10 +2250,10 @@
           CASE ( 'w*pt*BC' )
              dopr_index(i) = 21
-             dopr_unit(i)  = 'K m/s'
+             dopr_unit(i)  = TRIM ( heatflux_output_unit )
              hom(:,2,21,:) = SPREAD( zw, 2, statistic_regions+1 )
 
           CASE ( 'wptBC' )
              dopr_index(i) = 22
-             dopr_unit(i)  = 'K m/s'
+             dopr_unit(i)  = TRIM ( heatflux_output_unit )
              hom(:,2,22,:) = SPREAD( zw, 2, statistic_regions+1 )
 
@@ -2335,15 +2421,15 @@
           CASE ( 'w"vpt"' )
              dopr_index(i) = 45
-             dopr_unit(i)  = 'K m/s'
+             dopr_unit(i)  = TRIM ( heatflux_output_unit )
              hom(:,2,45,:) = SPREAD( zw, 2, statistic_regions+1 )
 
           CASE ( 'w*vpt*' )
              dopr_index(i) = 46
-             dopr_unit(i)  = 'K m/s'
+             dopr_unit(i)  = TRIM ( heatflux_output_unit )
              hom(:,2,46,:) = SPREAD( zw, 2, statistic_regions+1 )
 
           CASE ( 'wvpt' )
              dopr_index(i) = 47
-             dopr_unit(i)  = 'K m/s'
+             dopr_unit(i)  = TRIM ( heatflux_output_unit )
              hom(:,2,47,:) = SPREAD( zw, 2, statistic_regions+1 )
 
@@ -2356,5 +2442,5 @@
              ELSE
                 dopr_index(i) = 48
-                dopr_unit(i)  = 'kg/kg m/s'
+                dopr_unit(i)  = TRIM ( waterflux_output_unit )
                 hom(:,2,48,:) = SPREAD( zw, 2, statistic_regions+1 )
              ENDIF
@@ -2368,5 +2454,5 @@
              ELSE
                 dopr_index(i) = 49
-                dopr_unit(i)  = 'kg/kg m/s'
+                dopr_unit(i)  = TRIM ( waterflux_output_unit )
                 hom(:,2,49,:) = SPREAD( zw, 2, statistic_regions+1 )
              ENDIF
@@ -2380,5 +2466,5 @@
              ELSE
                 dopr_index(i) = 50
-                dopr_unit(i)  = 'kg/kg m/s'
+                dopr_unit(i)  = TRIM ( waterflux_output_unit )
                 hom(:,2,50,:) = SPREAD( zw, 2, statistic_regions+1 )
              ENDIF
@@ -2423,9 +2509,9 @@
              IF ( humidity  .AND.  .NOT.  cloud_physics )  THEN
                 dopr_index(i) = 48
-                dopr_unit(i)  = 'kg/kg m/s'
+                dopr_unit(i)  = TRIM ( waterflux_output_unit )
                 hom(:,2,48,:) = SPREAD( zw, 2, statistic_regions+1 )
              ELSEIF ( humidity  .AND.  cloud_physics )  THEN
                 dopr_index(i) = 51
-                dopr_unit(i)  = 'kg/kg m/s'
+                dopr_unit(i)  = TRIM ( waterflux_output_unit )
                 hom(:,2,51,:) = SPREAD( zw, 2, statistic_regions+1 )
              ELSE
@@ -2441,9 +2527,9 @@
              THEN
                 dopr_index(i) = 49
-                dopr_unit(i)  = 'kg/kg m/s'
+                dopr_unit(i)  = TRIM ( waterflux_output_unit )
                 hom(:,2,49,:) = SPREAD( zw, 2, statistic_regions+1 )
              ELSEIF( humidity .AND. cloud_physics ) THEN
                 dopr_index(i) = 52
-                dopr_unit(i)  = 'kg/kg m/s'
+                dopr_unit(i)  = TRIM ( waterflux_output_unit )
                 hom(:,2,52,:) = SPREAD( zw, 2, statistic_regions+1 )
              ELSE
@@ -2458,9 +2544,9 @@
              IF ( humidity  .AND.  .NOT.  cloud_physics )  THEN
                 dopr_index(i) = 50
-                dopr_unit(i)  = 'kg/kg m/s'
+                dopr_unit(i)  = TRIM ( waterflux_output_unit )
                 hom(:,2,50,:) = SPREAD( zw, 2, statistic_regions+1 )
              ELSEIF ( humidity  .AND.  cloud_physics )  THEN
                 dopr_index(i) = 53
-                dopr_unit(i)  = 'kg/kg m/s'
+                dopr_unit(i)  = TRIM ( waterflux_output_unit )
                 hom(:,2,53,:) = SPREAD( zw, 2, statistic_regions+1 )
              ELSE
@@ -2503,30 +2589,30 @@
           CASE ( 'u"pt"' )
              dopr_index(i) = 58
-             dopr_unit(i)  = 'K m/s'
+             dopr_unit(i)  = TRIM ( heatflux_output_unit )
              hom(:,2,58,:) = SPREAD( zu, 2, statistic_regions+1 )
 
           CASE ( 'u*pt*' )
              dopr_index(i) = 59
-             dopr_unit(i)  = 'K m/s'
+             dopr_unit(i)  = TRIM ( heatflux_output_unit )
              hom(:,2,59,:) = SPREAD( zu, 2, statistic_regions+1 )
 
           CASE ( 'upt_t' )
              dopr_index(i) = 60
-             dopr_unit(i)  = 'K m/s'
+             dopr_unit(i)  = TRIM ( heatflux_output_unit )
              hom(:,2,60,:) = SPREAD( zu, 2, statistic_regions+1 )
 
           CASE ( 'v"pt"' )
              dopr_index(i) = 61
-             dopr_unit(i)  = 'K m/s'
+             dopr_unit(i)  = TRIM ( heatflux_output_unit )
              hom(:,2,61,:) = SPREAD( zu, 2, statistic_regions+1 )
              
           CASE ( 'v*pt*' )
              dopr_index(i) = 62
-             dopr_unit(i)  = 'K m/s'
+             dopr_unit(i)  = TRIM ( heatflux_output_unit )
              hom(:,2,62,:) = SPREAD( zu, 2, statistic_regions+1 )
 
           CASE ( 'vpt_t' )
              dopr_index(i) = 63
-             dopr_unit(i)  = 'K m/s'
+             dopr_unit(i)  = TRIM ( heatflux_output_unit )
              hom(:,2,63,:) = SPREAD( zu, 2, statistic_regions+1 )
 
@@ -2621,6 +2707,16 @@
           CASE ( 'hyp' )
              dopr_index(i) = 72
-             dopr_unit(i)  = 'dbar'
+             dopr_unit(i)  = 'hPa'
              hom(:,2,72,:) = SPREAD( zu, 2, statistic_regions+1 )
+
+          CASE ( 'rho_air' )
+             dopr_index(i)  = 121
+             dopr_unit(i)   = 'kg/m3'
+             hom(:,2,121,:) = SPREAD( zu, 2, statistic_regions+1 )
+
+          CASE ( 'rho_air_zw' )
+             dopr_index(i)  = 122
+             dopr_unit(i)   = 'kg/m3'
+             hom(:,2,122,:) = SPREAD( zw, 2, statistic_regions+1 )
 
           CASE ( 'nr' )
Index: /palm/trunk/SOURCE/diffusion_e.f90
===================================================================
--- /palm/trunk/SOURCE/diffusion_e.f90	(revision 2036)
+++ /palm/trunk/SOURCE/diffusion_e.f90	(revision 2037)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Anelastic approximation implemented
 ! 
 ! Former revisions:
@@ -128,5 +128,6 @@
 
        USE arrays_3d,                                                          &
-           ONLY:  dd2zu, ddzu, ddzw, diss, e, km, l_grid, tend, zu, zw
+           ONLY:  dd2zu, ddzu, ddzw, diss, e, km, l_grid, tend, zu, zw,        &
+                  drho_air, rho_air_zw
            
        USE control_parameters,                                                 &
@@ -222,6 +223,8 @@
                                         + (                                    &
                ( km(k,j,i)+km(k+1,j,i) ) * ( e(k+1,j,i)-e(k,j,i) ) * ddzu(k+1) &
+                                                             * rho_air_zw(k)   &
              - ( km(k,j,i)+km(k-1,j,i) ) * ( e(k,j,i)-e(k-1,j,i) ) * ddzu(k)   &
-                                          ) * ddzw(k)                          &
+                                                             * rho_air_zw(k-1) &
+                                          ) * ddzw(k) * drho_air(k)            &
                              - dissipation(k,j)
 
@@ -294,6 +297,8 @@
                                         + (                                    &
                ( km(k,j,i)+km(k+1,j,i) ) * ( e(k+1,j,i)-e(k,j,i) ) * ddzu(k+1) &
+                                                             * rho_air_zw(k)   &
              - ( km(k,j,i)+km(k-1,j,i) ) * ( e(k,j,i)-e(k-1,j,i) ) * ddzu(k)   &
-                                          ) * ddzw(k)                          &
+                                                             * rho_air_zw(k-1) &
+                                          ) * ddzw(k) * drho_air(k)            &
                              - dissipation(k,j)
 
@@ -339,5 +344,6 @@
 
        USE arrays_3d,                                                          &
-           ONLY:  dd2zu, ddzu, ddzw, diss, e, km, l_grid, tend, zu, zw
+           ONLY:  dd2zu, ddzu, ddzw, diss, e, km, l_grid, tend, zu, zw,        &
+                  drho_air, rho_air_zw
           
        USE control_parameters,                                                 &
@@ -430,6 +436,8 @@
                                         + (                                    &
                ( km(k,j,i)+km(k+1,j,i) ) * ( e(k+1,j,i)-e(k,j,i) ) * ddzu(k+1) &
+                                                             * rho_air_zw(k)   &
              - ( km(k,j,i)+km(k-1,j,i) ) * ( e(k,j,i)-e(k-1,j,i) ) * ddzu(k)   &
-                                          ) * ddzw(k)                          &
+                                                             * rho_air_zw(k-1) &
+                                          ) * ddzw(k) * drho_air(k)            &
                                   - dissipation
 
@@ -497,6 +505,8 @@
                                         + (                                    &
                ( km(k,j,i)+km(k+1,j,i) ) * ( e(k+1,j,i)-e(k,j,i) ) * ddzu(k+1) &
+                                                             * rho_air_zw(k)   &
              - ( km(k,j,i)+km(k-1,j,i) ) * ( e(k,j,i)-e(k-1,j,i) ) * ddzu(k)   &
-                                          ) * ddzw(k)                          &
+                                                             * rho_air_zw(k-1) &
+                                          ) * ddzw(k) * drho_air(k)            &
                                   - dissipation
 
@@ -542,5 +552,6 @@
 
        USE arrays_3d,                                                          &
-           ONLY:  dd2zu, ddzu, ddzw, diss, e, km, l_grid, tend, zu, zw
+           ONLY:  dd2zu, ddzu, ddzw, diss, e, km, l_grid, tend, zu, zw,        &
+                  drho_air, rho_air_zw
           
        USE control_parameters,                                                 &
@@ -625,6 +636,8 @@
                                        + (                                    &
               ( km(k,j,i)+km(k+1,j,i) ) * ( e(k+1,j,i)-e(k,j,i) ) * ddzu(k+1) &
+                                                            * rho_air_zw(k)   &
             - ( km(k,j,i)+km(k-1,j,i) ) * ( e(k,j,i)-e(k-1,j,i) ) * ddzu(k)   &
-                                         ) * ddzw(k)                          &
+                                                            * rho_air_zw(k-1) &
+                                         ) * ddzw(k) * drho_air(k)            &
                                        - dissipation(k)
 
Index: /palm/trunk/SOURCE/diffusion_s.f90
===================================================================
--- /palm/trunk/SOURCE/diffusion_s.f90	(revision 2036)
+++ /palm/trunk/SOURCE/diffusion_s.f90	(revision 2037)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! Anelastic approximation implemented
 ! 
 ! Former revisions:
@@ -113,5 +113,5 @@
 
        USE arrays_3d,                                                          &
-           ONLY:  ddzu, ddzw, kh, tend
+           ONLY:  ddzu, ddzw, kh, tend, drho_air, rho_air_zw
        
        USE control_parameters,                                                 & 
@@ -190,6 +190,8 @@
                                        + 0.5_wp * (                            &
             ( kh(k,j,i) + kh(k+1,j,i) ) * ( s(k+1,j,i)-s(k,j,i) ) * ddzu(k+1)  &
+                                                            * rho_air_zw(k)    &
           - ( kh(k,j,i) + kh(k-1,j,i) ) * ( s(k,j,i)-s(k-1,j,i) ) * ddzu(k)    &
-                                                  ) * ddzw(k)
+                                                            * rho_air_zw(k-1)  &
+                                                  ) * ddzw(k) * drho_air(k)
              ENDDO
 
@@ -205,6 +207,7 @@
                                                   * ( s(k+1,j,i)-s(k,j,i) )    &
                                                   * ddzu(k+1)                  &
+                                                  * rho_air_zw(k)              &
                                            + s_flux_b(j,i)                     &
-                                         ) * ddzw(k)
+                                         ) * ddzw(k) * drho_air(k)
 
              ENDIF
@@ -222,5 +225,6 @@
                                                     * ( s(k,j,i)-s(k-1,j,i) )  &
                                                     * ddzu(k)                  &
-                                         ) * ddzw(k)
+                                                    * rho_air_zw(k-1)          &
+                                         ) * ddzw(k) * drho_air(k)
 
              ENDIF
@@ -240,5 +244,5 @@
 
        USE arrays_3d,                                                          &
-           ONLY:  ddzu, ddzw, kh, tend
+           ONLY:  ddzu, ddzw, kh, tend, drho_air, rho_air_zw
            
        USE control_parameters,                                                 & 
@@ -324,6 +328,8 @@
                                        + 0.5_wp * (                            &
             ( kh(k,j,i) + kh(k+1,j,i) ) * ( s(k+1,j,i)-s(k,j,i) ) * ddzu(k+1)  &
+                                                            * rho_air_zw(k)    &
           - ( kh(k,j,i) + kh(k-1,j,i) ) * ( s(k,j,i)-s(k-1,j,i) ) * ddzu(k)    &
-                                                  ) * ddzw(k)
+                                                            * rho_air_zw(k-1)  &
+                                                  ) * ddzw(k) * drho_air(k)
                 ENDIF
              ENDDO
@@ -338,6 +344,7 @@
                                                      * ( s(k+1,j,i)-s(k,j,i) ) &
                                                      * ddzu(k+1)               &
+                                                     * rho_air_zw(k)           &
                                               + s_flux_b(j,i)                  &
-                                            ) * ddzw(k)
+                                            ) * ddzw(k) * drho_air(k)
                 ENDIF
 
@@ -351,5 +358,6 @@
                                                        * ( s(k,j,i)-s(k-1,j,i) )  &
                                                        * ddzu(k)                  &
-                                            ) * ddzw(k)
+                                                       * rho_air_zw(k-1)          &
+                                            ) * ddzw(k) * drho_air(k)
                 ENDIF
              ENDDO
@@ -370,5 +378,5 @@
 
        USE arrays_3d,                                                          &
-           ONLY:  ddzu, ddzw, kh, tend
+           ONLY:  ddzu, ddzw, kh, tend, drho_air, rho_air_zw
            
        USE control_parameters,                                                 & 
@@ -446,6 +454,8 @@
                                        + 0.5_wp * (                            &
             ( kh(k,j,i) + kh(k+1,j,i) ) * ( s(k+1,j,i)-s(k,j,i) ) * ddzu(k+1)  &
+                                                            * rho_air_zw(k)    &
           - ( kh(k,j,i) + kh(k-1,j,i) ) * ( s(k,j,i)-s(k-1,j,i) ) * ddzu(k)    &
-                                                  ) * ddzw(k)
+                                                            * rho_air_zw(k-1)  &
+                                                  ) * ddzw(k) * drho_air(k)
        ENDDO
 
@@ -459,6 +469,7 @@
                                                * ( s(k+1,j,i)-s(k,j,i) )       &
                                                * ddzu(k+1)                     &
+                                               * rho_air_zw(k)                 &
                                         + s_flux_b(j,i)                        &
-                                      ) * ddzw(k)
+                                      ) * ddzw(k) * drho_air(k)
 
        ENDIF
@@ -474,5 +485,6 @@
                                                * ( s(k,j,i)-s(k-1,j,i) )       &
                                                * ddzu(k)                       &
-                                      ) * ddzw(k)
+                                               * rho_air_zw(k-1)               &
+                                      ) * ddzw(k) * drho_air(k)
 
        ENDIF
